// GraphView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CurveFit.h"
#include "GraphView.h"
#include "RealDC.h"
#include "SetupCurveFitView.h"
#include "..\IniFile.h"
#include "..\WinSub.h"
#include "..\..\Utils.h"

extern CIniFile *IniFile;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGraphView

IMPLEMENT_DYNCREATE(CGraphView, CScrollView)

CGraphView::CGraphView()
{
	m_IsSpecifyingRegion = false;
}

CGraphView::~CGraphView()
{
}


BEGIN_MESSAGE_MAP(CGraphView, CScrollView)
	//{{AFX_MSG_MAP(CGraphView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_VIEW_SELECTFONT, OnViewSelectfont)
	ON_WM_CREATE()
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, OnFilePrintPreview)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphView `

void CGraphView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: ̃r[Ŝ̃TCYvZĂB
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

void CGraphView::OnDraw(CDC* pDC)
{
	static bool IsDrawing = false;
	if(IsDrawing) return;
	IsDrawing = true;
	CDocument* pDoc = GetDocument();
	// TODO: ̈ʒuɕ`p̃R[hǉĂ
	CSize sizeTotal;
	sizeTotal.cx = sizeTotal.cy = 1000;
	SetScrollSizes(MM_TEXT, sizeTotal);

	CRealDC dc(pDC);
	CFont ViewFont;
	dc.CreatePointFontIndirect(&m_ViewLogFont, &ViewFont);
	CFont *pOrgFont = NULL;
	pOrgFont = dc.SelectObject(&ViewFont);

	GetDocument()->GetSetupCurveFitView()->UpdateData(TRUE);
	dc.TextOut(2.0, 2.0, GetDocument()->GetSetupCurveFitView()->m_PFCPath);
	CGraphFrameArray *pFrameArray = GetGraphFrameArray();
	CGraphFrame *pFrame = pFrameArray->GetGraphFrame(0);
	if(pFrame == NULL)
	{
		MessageBox("Can't get GraphFrame(0)", "Error");
		IsDrawing = false;
		return;
	}
	pFrame->m_IsClip = IniFile->GetBool("Setup", "ClipGraphFrame", false);

	CGraphData *pData = pFrame->GetGraphData(0);

	int iDrawData0, iDrawData1;
	if(pData)
	{
		iDrawData0 = pData->GetIndex(pFrame->ViewXMin());
		iDrawData1 = pData->GetIndex(pFrame->ViewXMax());
	}
	if(pFrameArray)
	{
		pFrameArray->SetClipGraphFrame(IniFile->Getbool("Setup", "ClipGraphFrame", true));
		pFrameArray->Plot(&dc, iDrawData0, iDrawData1);
	}
	if(pData == NULL)
	{
		IsDrawing = false;
		return;
	}
	pData->SetYAxisType(GetDocument()->m_iYAxisType);
	CPeakSearch *pPeak = GetDocument()->GetPeakSearch();
	pPeak->SetYAxisType(GetDocument()->m_iYAxisType);

	if(GetDocument()->GetSetupCurveFitView()->m_AutoRedraw &&
		(pPeak->m_nPeaks > 0 || pPeak->m_BGb[0] != 0.0))
		pPeak->CalcPeak(0);

	int i;
	if(IniFile->GetBool("Setup", "ClipGraphFrame", 1))
	{
		(pPeak->m_BG).m_IsClipedByGraphFrame = true; 
		(pPeak->m_Total).m_IsClipedByGraphFrame = true; 
		for(i = 0 ; i < (pPeak->m_Curves).nGraphData() ; i++)
		{
			CGraphData *pGraph = (pPeak->m_Curves).GetGraphData(i);
			if(pGraph == NULL) continue;
			pGraph->m_IsClipedByGraphFrame = true;
			pGraph->SetYAxisType(GetDocument()->m_iYAxisType);
		}
	}
	else
	{
		(pPeak->m_BG).m_IsClipedByGraphFrame = false; 
		(pPeak->m_Total).m_IsClipedByGraphFrame = false; 
		for(i = 0 ; i < (pPeak->m_Curves).nGraphData() ; i++)
		{
			CGraphData *pGraph = (pPeak->m_Curves).GetGraphData(i);
			if(pGraph == NULL) continue;
			pGraph->m_IsClipedByGraphFrame = false;
			pGraph->SetYAxisType(GetDocument()->m_iYAxisType);
		}
	}
	if(GetDocument()->m_ViewBackground)
		(pPeak->m_BG).Plot(&dc, pFrame, iDrawData0, iDrawData1);
	if(GetDocument()->m_ViewCalc)
		(pPeak->m_Total).Plot(&dc, pFrame, iDrawData0, iDrawData1);
	for(i = 0 ; i < (pPeak->m_Curves).nGraphData() ; i++)
	{
		CGraphData *pGraph = (pPeak->m_Curves).GetGraphData(i);
		if(pGraph == NULL) continue;
		if(GetDocument()->m_ViewCurves ||
			(pPeak->m_iCurrentPeak == i && GetDocument()->m_ViewCurrentCurve))
				pGraph->Plot(&dc, pFrame, iDrawData0, iDrawData1);
	}
	static RECT rt;
	double w, h;
	dc.GetTextExtent(CString("W"), &w, &h);
	rt.left = dc.SizeToPixelX(10.0);
	rt.right = rt.top+dc.SizeToPixelX(300.0);
	rt.top = dc.SizeToPixelY(pFrame->GraphPosY0()+h*3);
	rt.bottom = rt.top+dc.SizeToPixelY(300.0);
	dc.DrawText(GetDocument()->m_Comment, &rt, DT_NOCLIP | DT_EXPANDTABS | DT_LEFT | DT_TOP | DT_WORDBREAK);

	if(pOrgFont) dc.SelectObject(pOrgFont);
	IsDrawing = false;
}

/////////////////////////////////////////////////////////////////////////////
// CGraphView ff

#ifdef _DEBUG
void CGraphView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CGraphView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGraphView bZ[W nh

void CGraphView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(m_IsSpecifyingRegion)
	{
		m_IsSpecifyingRegion = false;
	}
	else
	{
		m_IsSpecifyingRegion = true;
		m_PrevPoint = m_StartPoint = point;
	}
	
	CScrollView::OnLButtonDown(nFlags, point);
}

void CGraphView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(m_IsSpecifyingRegion)
	{
		m_IsSpecifyingRegion = false;
		CClientDC dc(this);
		CRealDC DC(&dc);
		double x0, y0, x1, y1;
		CGraphFrame *pFrame = GetGraphFrame(0);
		CPoint offset = GetScrollPosition();
		pFrame->PixelToVal(&DC, m_StartPoint.x+offset.x, m_StartPoint.y+offset.y, &x0, &y0);
		pFrame->PixelToVal(&DC, point.x+offset.x, point.y+offset.y, &x1, &y1);
		if(x0 != x1 && y0 != y1)
		{
			if(pFrame->IsInsideFrame(x0, y0) || pFrame->IsInsideFrame(x1, y1))
			{
				if(x0 > x1)
					CUtils::SwapDouble(x0, x1);
				if(x0 > x1)
					CUtils::SwapDouble(x0, x1);
				pFrame->SetViewRegion(x0, y0, x1, y1);
				GetDocument()->UpdateAllViews(NULL);//Invalidate();
			}
			else
			{
				CRgn rgn;
				rgn.CreateRectRgn(m_StartPoint.x, m_StartPoint.y,
							 point.x, point.y);
				CClientDC dc(this);
				CRealDC DC(&dc);
				DC.InvertRgn(&rgn);
			}
		}
		else
		{
			CRgn rgn;
			rgn.CreateRectRgn(m_StartPoint.x, m_StartPoint.y,
						 point.x, point.y);
			CClientDC dc(this);
			CRealDC DC(&dc);
			DC.InvertRgn(&rgn);
		}
	}

	CScrollView::OnLButtonUp(nFlags, point);
}

void CGraphView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(m_IsSpecifyingRegion)
	{
		CRgn rgn;
		rgn.CreateRectRgn(m_StartPoint.x, m_StartPoint.y,
							 m_PrevPoint.x, m_PrevPoint.y);
		CClientDC dc(this);
		CRealDC DC(&dc);
		DC.InvertRgn(&rgn);
		CRgn rgn2;
		rgn2.CreateRectRgn(m_StartPoint.x, m_StartPoint.y,
							  point.x, point.y);
		DC.InvertRgn(&rgn2);
		m_PrevPoint = point;
	}
	
	CScrollView::OnMouseMove(nFlags, point);
}

void CGraphView::OnViewSelectfont() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CClientDC dc(this);
	CRealDC DC(&dc);
	DC.CharSizePointToPixel(&m_ViewLogFont);
	CFontDialog fd(&m_ViewLogFont);
	
	if(fd.DoModal() == IDOK)
	{
		LOGFONT lf;
		fd.GetCurrentFont(&lf);
		memcpy(&m_ViewLogFont, &lf, sizeof(LOGFONT));
		DC.CharSizePixelToPoint(&m_ViewLogFont);
		Invalidate();
		IniFile->WriteString("GraphView", "ViewFontFaceName", m_ViewLogFont.lfFaceName);
		IniFile->WriteInt("GraphView", "ViewFontHeight", m_ViewLogFont.lfHeight);
	}
	else DC.CharSizePixelToPoint(&m_ViewLogFont);
}

int CGraphView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CScrollView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ
	memset(&m_ViewLogFont, 0, sizeof(LOGFONT));
	IniFile->GetString("GraphView", "ViewFontFaceName", "", m_ViewLogFont.lfFaceName);
	if(*(m_ViewLogFont.lfFaceName) != 0)
	{
		m_ViewLogFont.lfHeight = IniFile->GetInt("GraphView", "ViewFontHeight", 0);
		m_ViewLogFont.lfEscapement = 0;
		m_ViewLogFont.lfItalic = 0;
		m_ViewLogFont.lfStrikeOut = 0;
		m_ViewLogFont.lfUnderline = 0;
	}
	else
	{
		CFont *pFont = GetFont();
		if(pFont)
			pFont->GetLogFont(&m_ViewLogFont);
		else
		{
			memset(&m_ViewLogFont, 0, sizeof(LOGFONT));
			strcpy(m_ViewLogFont.lfFaceName, "Times New Roman");
			m_ViewLogFont.lfHeight = -24;
		}
		m_ViewLogFont.lfEscapement = 0;
		m_ViewLogFont.lfItalic = 0;
		m_ViewLogFont.lfStrikeOut = 0;
		m_ViewLogFont.lfUnderline = 0;
		CClientDC dc(this);
		CRealDC DC(&dc);
		DC.CharSizePixelToPoint(&m_ViewLogFont);
	}

	return 0;
}

void CGraphView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	CScrollView::OnBeginPrinting(pDC, pInfo);
}

void CGraphView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	CScrollView::OnEndPrinting(pDC, pInfo);
}

void CGraphView::OnEndPrintPreview(CDC* pDC, CPrintInfo* pInfo, POINT point, CPreviewView* pView) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	CScrollView::OnEndPrintPreview(pDC, pInfo, point, pView);
}

BOOL CGraphView::OnPreparePrinting(CPrintInfo* pInfo) 
{
	// TODO: _CAO {bNX\邽߂ DoPreparePrinting ĂяoĂ
	
//	return CScrollView::OnPreparePrinting(pInfo);
	return DoPreparePrinting(pInfo);
}

void CGraphView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	CScrollView::OnPrint(pDC, pInfo);
}

void CGraphView::OnFilePrintPreview() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CScrollView::OnFilePrintPreview();
}

void CGraphView::OnFilePrint() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CScrollView::OnFilePrint();
}

void CGraphView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	{
		if (point.x == -1 && point.y == -1){
			//L[Xg[N̔
			CRect rect;
			GetClientRect(rect);
			ClientToScreen(rect);

			point = rect.TopLeft();
			point.Offset(5, 5);
		}

		CMenu menu;
		VERIFY(menu.LoadMenu(CG_IDR_POPUP_CURVE_FIT_EDIT_VIEW));

		CMenu* pPopup = menu.GetSubMenu(0);
		ASSERT(pPopup != NULL);
		CWnd* pWndPopupOwner = this;

		while (pWndPopupOwner->GetStyle() & WS_CHILD)
			pWndPopupOwner = pWndPopupOwner->GetParent();

		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
			pWndPopupOwner);
	}
}
