// ReadDC.cpp: CReadDC NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RealDC.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CRealPoint::CRealPoint(double x0, double y0)
{
	x = x0;
	y = y0;
}

CRealPoint::~CRealPoint()
{

}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CRealRect::CRealRect(double x0, double y0, double x1, double y1)
{
	left = x0;
	bottom = y0;
	right = x1;
	top = y1;
}

CRealRect::~CRealRect()
{

}

CRealRect &CRealRect::SetNormalizedRect(double x0, double y0, double x1, double y1)
{
	if(x0 < x1)
	{
		left = x0;
		right = x1;
	}
	else
	{
		left = x1;
		right = x0;
	}
	if(y0 < y1)
	{
		bottom = y0;
		top = y1;
	}
	else
	{
		bottom = y1;
		top = y0;
	}

	return *this;
}

CRealRect &CRealRect::operator=(CRealRect &rt)
{
	left = rt.left;
	right = rt.right;
	top = rt.top;
	bottom = rt.bottom;
	return *this;
}

CRealRect &CRealRect::operator+=(CRealRect &rt)
{
	if(left > rt.left) left = rt.left;
	if(right < rt.right) right = rt.right;
	if(top < rt.top) top = rt.top;
	if(bottom > rt.bottom) bottom = rt.bottom;
	return *this;
}

/*
CRealRect &CRealRect::operator+(CRealRect &rt1, CRealRect &rt2)
{
	if(rt1.left > rt2.left) left = rt1.left;
	else left = rt2.left;
	if(rt1.right < rt2.right) right = rt1.right;
	else right = rt2.right;
	if(rt1.top < rt2.top) top = rt1.top;
	else top = rt2.top;
	if(rt1.bottom > rt2.bottom) bottom = rt1.bottom;
	else bottom = rt2.bottom;
	return *this;
}
*/

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CRealDC::CRealDC(CDC *pdc)
{
	Attach(pdc->m_hDC);
	GetDeviceInfo();
}

CRealDC::~CRealDC()
{
	Detach();
}

int CRealDC::GetDeviceInfo()
{
	m_HorzSize    = GetDeviceCaps(HORZSIZE);
	m_VertSize    = GetDeviceCaps(VERTSIZE);
	m_HorzRes     = GetDeviceCaps(HORZRES);
	m_VertRes     = GetDeviceCaps(VERTRES);
	m_BitsPixel   = GetDeviceCaps(BITSPIXEL);
	m_AspectX     = GetDeviceCaps(ASPECTX);
	m_AspectY     = GetDeviceCaps(ASPECTY);
	m_mmPerPixelX = (double)m_HorzSize / (double)m_HorzRes;
	m_mmPerPixelY = (double)m_VertSize / (double)m_VertRes;
	m_PixelPermmX = (double)m_HorzRes / (double)m_HorzSize;
	m_PixelPermmY = (double)m_VertRes / (double)m_VertSize;
	m_CharPointPerPixelX = m_mmPerPixelX / (25.4/72);
	m_CharPointPerPixelY = m_mmPerPixelY / (25.4/72);
	m_ViewMagnification = 1.0;
	m_ViewCharMag = 1.0;
	m_OffsetX = 0.0;
	m_OffsetY = 0.0;

	return 0;
}

CPoint CRealDC::MoveTo(double x, double y)
{
/*
	char str[256];
	sprintf(str, "%d %d", SizeToPixelX(x), SizeToPixelY(y));
	MessageBox(NULL, str, str, MB_OK);
*/
	return CDC::MoveTo(SizeToPixelX(x), SizeToPixelY(y));
}

CPoint CRealDC::LineTo(double x, double y, int linestyle, double linewidth, COLORREF linecolor)
{
	CPen NewPen(linestyle, GetIntWidth(linewidth), linecolor);
	CPen *pOrgPen = SelectObject(&NewPen);
/*
	char str[256];
	sprintf(str, "%d %d", SizeToPixelX(x), SizeToPixelY(y));
	MessageBox(NULL, str, str, MB_OK);
*/
	CPoint pt = CDC::LineTo(SizeToPixelX(x), SizeToPixelY(y));

	SelectObject(pOrgPen);
	return pt;
}

CRealRect &CRealDC::Line(double x0, double y0, double x1, double y1,
		int linestyle, double linewidth, COLORREF linecolor)
{
	MoveTo(x0, y0);
	LineTo(x1, y1, linestyle, linewidth, linecolor);
	static CRealRect rt;
	rt.SetNormalizedRect(x0, y0, x1, y1);

	return rt;
} 

BOOL CRealDC::Ellipse(double x0, double y0, double x1, double y1,
		int linestyle, double linewidth, COLORREF linecolor,
		int fillstyle, COLORREF hatchcolor, int hatchstyle)
{
//PS_SOLID ̃y쐬܂B
//PS_DASH   j̃y쐬܂ByfoCXP 1 ȉ̏ꍇLłB
//PS_DOT   _̃y쐬܂ByfoCXP 1 ȉ̏ꍇLłB
//PS_DASHDOT   _j̃y쐬܂ByfoCXP 1 ȉ̏ꍇLłB
//PS_DASHDOTDOT   _j̃y쐬܂ByfoCXP 1 ȉ̏ꍇLłB
//PS_NULL ̃y쐬܂B
//PS_INSIDEFRAME Oڂlp`w肷 Windows  GDI ̏o͊֐ (Ƃ΁AEllipseARectangleARoundRectAPieAChord o֐) ō쐬}`̘g̓ɒ`悷y쐬܂BOڂlp`w肵Ȃ Windows  GDI o͊֐ (Ƃ΁ALineTo o֐) ō쐬}`̂Ƃ́Ay̕`̈͐}`̘gɋK܂B
	CPen NewPen(linestyle, GetIntWidth(linewidth), linecolor);
	CPen *pOrgPen = SelectObject(&NewPen);
	CBrush NewBrush;
	LOGBRUSH lb;
//BS_DIBPATTERN 
//BS_DIBPATTERN8X8 
//BS_DIBPATTERNPT 
//BS_HATCHED 
//BS_HOLLOW 
//BS_NULL 
//BS_PATTERN 
//BS_PATTERN8X8 
//BS_SOLID 
	lb.lbStyle = fillstyle;
	lb.lbColor = hatchcolor;
//HS_BDIAGONAL 45 x̉Eΐnb`
//HS_CROSS Åiqnb`
//HS_DIAGCROSS 45 x̎΂ߊiqnb`
//HS_FDIAGONAL 45 x̉Eオnb`
//HS_HORIZONTAL nb`
//HS_VERTICAL nb`
	lb.lbHatch = hatchstyle;
	NewBrush.CreateBrushIndirect(&lb);
	CBrush *pOrgBrush = SelectObject(&NewBrush);

	BOOL b = CDC::Ellipse(SizeToPixelX(x0), SizeToPixelY(y0),
							SizeToPixelX(x1), SizeToPixelY(y1));
	SelectObject(pOrgPen);
	SelectObject(pOrgBrush);
	return b;
}

CRealRect &CRealDC::Rectangle(double x0, double y0, double x1, double y1,
		int linestyle, double linewidth, COLORREF linecolor,
		int fillstyle, COLORREF hatchcolor, int hatchstyle)
{
	CPen NewPen(linestyle, GetIntWidth(linewidth), linecolor);
	CPen *pOrgPen = SelectObject(&NewPen);
	CBrush NewBrush;
	LOGBRUSH lb;
	lb.lbStyle = fillstyle;
	lb.lbColor = hatchcolor;
	lb.lbHatch = hatchstyle;
	NewBrush.CreateBrushIndirect(&lb);
	CBrush *pOrgBrush = SelectObject(&NewBrush);

	CDC::Rectangle(SizeToPixelX(x0), SizeToPixelY(y0),
							SizeToPixelX(x1), SizeToPixelY(y1));
	SelectObject(pOrgPen);
	SelectObject(pOrgBrush);

	static CRealRect rt;
	rt.SetNormalizedRect(x0, y0, x1, y1);
	return rt;
}

CRealRect &CRealDC::TextOut(double x, double y, CString str, double directionangle)
{
	CFont *pOrgFont = NULL;
	CFont ft;
	if(directionangle != 0.0)
	{
		LOGFONT lf;
		GetCurrentFont()->GetLogFont(&lf);
		CharSizePixelToPoint(&lf);
		lf.lfEscapement = 900; //(int)(directionangle*10.0+1e-5);
		CreatePointFontIndirect(&lf, &ft);
		pOrgFont = SelectObject(&ft);
	}
	double w, h;
	GetTextExtent(str, &w, &h);
	static CRealRect rt;
	rt.SetNormalizedRect(x, y, x+w, y+h);
	CDC::TextOut(SizeToPixelX(x), SizeToPixelY(y), str);
	if(pOrgFont) SelectObject(pOrgFont);
	return rt;
}

int CRealDC::GetTextExtent(CString str, double *w, double *h)
{
	CSize size = CDC::GetTextExtent(str);
	*w = (double)size.cx * m_mmPerPixelX;
	*h = (double)size.cy * m_mmPerPixelY;
	return 0;
}

BOOL CRealDC::CreateFontIndirect(const LOGFONT * lpLogFont, CFont * font)
{
	LOGFONT lf;
	memcpy(&lf, lpLogFont, sizeof(LOGFONT));

	lf.lfHeight = (long)((double)lf.lfHeight*m_CharPointPerPixelY*10.0+1e-5);
	lf.lfWidth  = (long)((double)lf.lfWidth*m_CharPointPerPixelX*10.0+1e-5);
	return font->CreatePointFontIndirect(&lf);
}

int CRealDC::GetIntWidth(double width)
{
	int w = (int)(width * m_PixelPermmX + 1.0e-5);
	if(w > 0) return w;
	else return 1;
}

CString & CRealDC::GetDeviceInfoString()
{
	static CString str;
	CString s;
	str.Format("HorzSize: %d   VertSize: %d\r\n", m_HorzSize, m_VertSize);
	s.Format("HorzRes: %d   VertRes: %d\r\n", m_HorzRes, m_VertRes);
	str += s;
	s.Format("BitsPixel: %d\r\n", m_BitsPixel);
	str += s;
	s.Format("AspectX: %g   AspectY: %g\r\n", m_AspectX, m_AspectY);
	str += s;
	s.Format("mmPerPixelX: %g   mmPerPixelY: %g\r\n", m_mmPerPixelX, m_mmPerPixelY);
	str += s;
	s.Format("PixelPermmX: %g   PixelPermmY: %g\r\n", m_PixelPermmX, m_PixelPermmY);
	str += s;
	s.Format("CharPointPerPixelX: %g   CharPointPerPixelY: %g\r\n",
					m_CharPointPerPixelX, m_CharPointPerPixelX);
	str += s;
	s.Format("ViewMag: %g   ViewCharMag: %g\r\n", m_ViewMagnification, m_ViewCharMag);
	str += s;
	s.Format("OffsetX: %g   OffsetY: %g\r\n", m_OffsetX, m_OffsetY);
	str += s;

	return str;
}

BOOL CRealDC::CreatePointFontIndirect(const LOGFONT * lpLogFont, CFont * font)
{
	return font->CreatePointFontIndirect(lpLogFont, this);
}

int CRealDC::CharSizePixelToPoint(LOGFONT *lpLogFont)
{
	lpLogFont->lfHeight = (long)((double)lpLogFont->lfHeight*m_CharPointPerPixelY+0.5)*10;
	lpLogFont->lfWidth  = (long)((double)lpLogFont->lfWidth *m_CharPointPerPixelX+0.5)*10;

	return 0;
}

int CRealDC::CharSizePointToPixel(LOGFONT *lpLogFont)
{
	lpLogFont->lfHeight = (long)((double)lpLogFont->lfHeight/10.0/m_CharPointPerPixelY+0.5);
	lpLogFont->lfWidth  = (long)((double)lpLogFont->lfWidth /10.0/m_CharPointPerPixelX+0.5);

	return 0;
}
